/*---------------------------------------------------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | Multiphase Code Repository by HZDR
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.767
  ||  ||  //    ||  // || \\   | License: GPL-3.0-or-later
  ==  == ====== ====   ==  ==  |
-------------------------------------------------------------------------------
License
    This file is part of the Multiphase Code Repository by HZDR.

    Copyright (C) 2025 by Helmholtz-Zentrum Dresden-Rossendorf e.V. (HZDR),
    Website: https://hzdr.de

    Multiphase Code Repository by HZDR is based on the free software for
    computational fluid dynamics (CFD) from the OpenFOAM Foundation.
    Copyright (C) 2025 by OpenFOAM Foundation, Website: https://openfoam.org

    If you are interested in which files are original OpenFOAM Foundation
    files, which OpenFOAM Foundation files were modified, and which files were
    newly created, see FILES.md.

    Multiphase Code Repository by HZDR is free software: you can redistribute
    it and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Multiphase Code Repository by HZDR is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
    Public License for more details.

    You should have received a copy of the GNU General Public License along
    with the Multiphase Code Repository by HZDR. If not, see
    <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "accumulationToContinuous.H"
#include "addToRunTimeSelectionTable.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

namespace Foam
{
namespace fv
{
    defineTypeNameAndDebug(accumulationToContinuous, 0);
    addToRunTimeSelectionTable
    (
        morphologyTransferModel,
        accumulationToContinuous,
        dictionary
    );
}
}


// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::fv::accumulationToContinuous::accumulationToContinuous
(
    const dictionary& dict,
    const dispersedPhaseInterface& interface
)
:
    morphologyTransferModel(dict, interface),
    disperse_(interface_.dispersed()),
    continuous_(interface_.continuous()),
    alphaThreshold_
    (
        "alphaThreshold",
        dimless,
        dict,
        continuous_.continuousThreshold().value()
    ),
    continuousMin_
    (
        dict.lookupOrDefault<scalar>("continuousMin", dimless, Zero)
    ),
    otherPhases_
    (
        dict.lookupOrDefault<wordList>("otherPhases", wordList())
    ),
    maskName_(dict.lookupOrDefault<word>("mask", word::null))
{
    if (disperse_.continuous() || !continuous_.continuous())
    {
        Warning
            << "Expecting a disperseddispersedPhaseInterface of structure "
            << "<disperse>_dispersedIn_<continuous> in interface "
            << interface.name() << " for " << typeName << " model."
            << endl;
    }
}


// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //

Foam::fv::accumulationToContinuous::~accumulationToContinuous()
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

Foam::tmp<Foam::volScalarField::Internal>
Foam::fv::accumulationToContinuous::dmdtf() const
{
    volScalarField alphaSum(continuous_ + disperse_);

    // Add other (disperse) phases
    forAll(otherPhases_, i)
    {
        const volScalarField& alphaOther =
            interface_.mesh().lookupObject<volScalarField>
            (
                IOobject::groupName("alpha", otherPhases_[i])
            );

        alphaSum += alphaOther;
    }

    tmp<volScalarField::Internal> tdmdtf
    (
        volScalarField::Internal::New
        (
            IOobject::groupName
            (
                IOobject::groupName("dmdtf", typeName),
                interface_.name()
            ),
            pos0(alphaSum.internalField() - alphaThreshold_)
           *pos0(continuous_.internalField() - continuousMin_)
           *rate(disperse_)
        )
    );

    // Allow transfer only in regions where mask field has positive values
    if (maskName_ != word::null)
    {
        const volScalarField& mask =
            interface_.mesh().lookupObject<volScalarField>(maskName_);

        tdmdtf.ref() *= pos(mask.internalField());
    }

    return tdmdtf;
}


// ************************************************************************* //
